{
 Ŀ
                               EMS-SHARP                                 
   ⥪  ࠡ  EMS   ணࠬ  Turbo Pascal 7.0   
                      Coded by VanDamM, 14-07-97                         
                          All right reserved                             
 
}
{F+}
Unit E_SHARP;
Interface
Var
    EmsError : byte;
    EmsSegment, LogPages, FreePages, EmsPrefix : word;

    Procedure EmsStatus;

    Procedure EmsSegmentDetect;

    Procedure EmsMemAvail;

    Procedure EmsAlloc(Pages : word);

    Procedure EmsMap(Handle : word; Pages : array of word);

    Procedure EmsSave(Handle : word);

    Procedure EmsRestore(Handle : word);

    Function  EmsVersion : byte;

    Procedure EmsFree(Handle : word);

    Procedure EmsMemoryBlockSave(Segment : Word; Offset1 : Word;
                                   Offset2 : Word; Bytes : Word);

    Procedure EmsMemoryBlockLoad(Segment : Word; Offset1 : Word;
                                   Offset2 : Word; Bytes : Word);

Implementation

    Procedure EmsStatus;
     Begin
      asm
       mov ah, 40h
       int 67h
       mov EmsError, ah
      end;
     End;

    Procedure EmsSegmentDetect;
     Begin
      asm
       mov ah, 41h
       int 67h
       mov EmsError, ah
       mov EmsSegment, bx
      end;
     End;

    Procedure EmsMemAvail;
     Begin
      asm
       mov ah, 42h
       int 67h
       mov EmsError, ah
       mov LogPages, bx
       mov FreePages, dx
      end;
     End;

    Procedure EmsAlloc(Pages : word);
     Begin
      asm
       mov bx, Pages
       mov ah, 43h
       int 67h
       mov EmsError, ah
       mov EmsPrefix, dx
      end;
     End;

    Procedure EmsMap(Handle : word; Pages : array of word);
      Var i : byte;
          j : word;
     Begin
      For i:=0 to 3 do
       Begin
        j:=Pages[i];
        asm
         mov bx, j
         mov dx, Handle
         mov ah, 44h
         mov al, i
         int 67h
         mov EmsError, ah
        end;
       End;
     End;

    Procedure EmsSave(Handle : word);
     Begin
        asm
         mov dx, Handle
         mov ah, 47h
         int 67h
         mov EmsError, ah
        end;
     End;

    Procedure EmsRestore(Handle : word);
     Begin
        asm
         mov dx, Handle
         mov ah, 48h
         int 67h
         mov EmsError, ah
        end;
     End;

    Function EmsVersion : byte;
      Var i : byte;
     Begin
        asm
         mov ah, 46h
         int 67h
         mov EmsError, ah
         mov i, al
        end;
      EmsVersion:=i;
     End;

    Procedure EmsFree(Handle : word);
     Begin
        asm
         mov dx, Handle
         mov ah, 45h
         int 67h
         mov EmsError, ah
        end;
     End;

    Procedure EmsMemoryBlockSave(Segment : Word; Offset1 : Word;
                                   Offset2 : Word; Bytes : Word);
     Begin
        asm
         cld
         mov ax, Segment
         mov ds, ax
         mov ax, EmsSegment
         mov es, ax
         mov si, Offset1
         mov di, Offset2
         mov cx, Bytes
         rep movsb
        end;
     End;

    Procedure EmsMemoryBlockLoad(Segment : Word; Offset1 : Word;
                                   Offset2 : Word; Bytes : Word);
     Begin
        asm
         cld
         mov ax, Segment
         mov es, ax
         mov ax, EmsSegment
         mov ds, ax
         mov di, Offset1
         mov si, Offset2
         mov cx, Bytes
         rep movsb
        end;
     End;
End.